////////////////////////////////////////////////////////////////////////////////
// The HUE Philis driver v 1.1
//////////////////////////////////////////////////////////////////////////////// 
var HUE_GUI; 
function HUE(ip){                                                               // ip arguments is the IP adrees of your bridge
   
   var user = IR.HWID;                                                          // Get a HWID form device
   user = "iridiumuser" + user.charAt(0) + user.charAt(1) + user.charAt(2);     // Create a username is based on HWID   
   
   var dev = IR.GetDevice("HUE");                                               // Get the link to driver           
   dev.SetParameters({Host: ip, Port: 80});                                     // Parammeters is setted to driver
   
   var data = [",/api",                                                         // 0 - start the request
               "\r\n\r\n",                                                      // 1 - end the request
               ",/api/" + user + "/lights/",                                    // 2 - lights request
               ",/api/" + user + "/groups/",                                    // 3 - grous request
               ",/api/" + user + "/schedules/",                                 // 4 - schedules request
               ",/api/" + user + "/config/"                                     // 5 - config request
              ];
                  
   var light_current = 1;                                                       // The current light   
                         
   var color = 0;                                                               // The color from Picker in number space  
   var red = 0;                                                                 // The Red color in RGB space
   var green = 0;                                                               // The Green color in RGB space
   var blue = 0;                                                                // The Blue color in RGB space
   
   var light_array = [];                                                        // Parameters of lights Array 
                                                                                                                        
   var state = 0;                                                               // A state of connection, 0 - default, 1 - connect
   var id_des = null;                                                               // The id for link Interval function
   var id_1 = null;

////////////////////////////////////////////////////////////////////////////////
// The Parser
////////////////////////////////////////////////////////////////////////////////   
   function parse(t){  
      HUE_GUI.page.HidePopup(HUE_GUI.disconnect.Name);                          // Disconnect Popup is hided      
      remove_disconect_detector();                                              // Disconnect detector is removed
                                                   
      if(t.charAt(0) + t.charAt(1) == "<h") return;                             // The bug of cleint fixing
         
      //IR.Log(t)                                                                 // Message is showed to Console
      
      t = JSON.Parse(t);                                                        // The JSON is created from received data      
                                   
      var id = [];                                                              // Array of indexes is declared          
      if(!(t instanceof Array))                                                 // If type of JSON isn't array then it is transformed to array 
         t = [t];                                                                  
                                            
      for(var x in t[0])                                                        // Zero item from array of JSON is indexed
         id.push(x);
          
      switch(id[0]){                                                            // looking for coincidence
         case "success":                                                        // Zero index is message of success 
            id = [];                                                            // Clear the Array of index
            
            for(var x in t[0].success)                                          // Success section is indexed
               id.push(x);   
            
            switch(id[0]){                                                      // looking for coincidence
               case "username":                                                 // User is authorized | Also, path of read - t.success.username
                  getall();                                                     // Send request for get all data of devices on the bridge                   
               break;
               
               case "/lights":                                                  // The search have been started | { "success": { "/lights": "Searching for new devices" } }      
               break;
                                                                                                                       
               case "1":                                                        // requset the count of the lights /api/<username>/lights                     
                  for(var i = 1; i <= id.length; i++)                           // fill array lishts name
                     light_array[i - 1].name = t.success[i.toString()].name;
                    
                  setLightNumber(light_current);                                // draw list, select current lights
               break;                                                        
               
               default:
                 
                 var id_2;
                                       
                  for(var i = 0; i < t.length; i++){
                     
                     for(var x in t[i].success)                                 // Lights section is indexed
                        id_2 = x;
                        var nummber = id_2.split("/");
                                                                                           // Inform the user
                        switch(id_2.charAt(id_2.length - 2) + id_2.charAt(id_2.length - 1)){
                           case "ri":
                              light_array[nummber[2] - 1].bri = t[i].success[id_2];
                           break;
                           
                           case "on":
                              light_array[nummber[2] - 1].swit = t[i].success[id_2]; 
                           break;
                           
                           case "ue":
                              light_array[nummber[2] - 1].hue = t[i].success[id_2];
                           break;
                           
                           case "at":
                              light_array[nummber[2] - 1].sat = t[i].success[id_2];
                           break;
                        }
                     } 
                  ColorLoader();                                                // Draw data
               break;                                            
            } 
         break;
        
         case "error":                                                          // id[0] - error message What to Do!
            switch(t[0].error.type){
               case 1:                                                          // unauthorized user
               case 101:                                                        // link button not pressed
                  HUE_GUI.page.ShowPopup(HUE_GUI.user.Name);   
                  auth();         
               break;
               
               case 2:                                                          // syntax error
                  //set_switch_sat_bri_hue();
                  last();
               break;
               
               case 201:
                   HUE_GUI.page.ShowPopup(HUE_GUI.message.Name);
                   
                   IR.SetTimeout(500, function(){
                        HUE_GUI.page.ShowPopup(HUE_GUI.message.Name);
                   });
               break;    
               
               case 3:                                                          // not error happend
               case 4:
               case 5:
               case 6:
               case 7:
               case 8:   
               case 301:
               case 302:
               case 901:
               break;         
            }      
         break;
         
         case "modelid":                                                        // id[0] - сообщение о состоянии лампы, прочитаем и отобразим    

            light_array[light_current - 1].swit = t[0].state.on;  
            light_array[light_current - 1].sat = t[0].state.sat; 
            light_array[light_current - 1].bri = t[0].state.bri;
            light_array[light_current - 1].hue = t[0].state.hue;
            ColorLoader();                                                      // рисуем данные
         break;
         
         case "config":                                                         // id[0] - сообщение о состоянии системы в целом
            HUE_GUI.page.HidePopup(HUE_GUI.wait.Name);                          // скроем попап ожидания
            id = [];       
            for(var x in t[0].lights)                                           // Lights section is indexed
               id.push(x); 
             
            for(var i = 1; i <= id.length; i++)                                // Filling the array
               light_array[i - 1] = {
                  name: t[0].lights[i.toString()].name,
                  swit: t[0].lights[i.toString()].state.on,
                  sat:  t[0].lights[i.toString()].state.sat,
                  bri:  t[0].lights[i.toString()].state.bri,
                  hue:  t[0].lights[i.toString()].state.hue,
               }     
                     
              setLightNumber(light_current);                                       // Draw the light and set current
              
              IR.ClearInterval(id_1)
              id_1 = IR.SetInterval(3000, getlight); 
              
         break;                                   
           // TODO для групп, таймеров и пользователей t[0].schedules[i.toString()]["name"], t[0].groups[i.toString()]["name"], t[0].config.whitelist надо индексировать
      }         
      DataReflection();
   }             
////////////////////////////////////////////////////////////////////////////////
// Converters
////////////////////////////////////////////////////////////////////////////////     
   function rgb_to_hsv(){                                                       // RGB to HSV
       var rr, gg, bb,
           r = arguments[0] / 255,
           g = arguments[1] / 255,
           b = arguments[2] / 255,
           h, s,
           v = Math.max(r, g, b),
           diff = v - Math.min(r, g, b),
           diffc = function(c){
               return (v - c) / 6 / diff + 1 / 2;
           }
   
      if(diff == 0)
           h = s = 0;
      else{
        s = diff / v;
        rr = diffc(r);
        gg = diffc(g);
        bb = diffc(b);
   
        if (r === v)
            h = bb - gg;
        else if (g === v)
            h = (1 / 3) + rr - bb;
        else if (b === v)
            h = (2 / 3) + gg - rr;
        
        if (h < 0)
            h += 1;
        else if (h > 1)
            h -= 1;
       }
       return [
           Math.round(h * 65535),
           Math.round(s * 255),
           Math.round(v * 255)
       ];
   }         
    
   function HSVtoRGB(h, s, v) {                                                 // HSV to RGB 
       var r, g, b, i, f, p, q, t;
       if (h && s === undefined && v === undefined) {
           s = h.s, v = h.v, h = h.h;
       }
       i = Math.floor(h * 6);
       f = h * 6 - i;
       p = v * (1 - s);
       q = v * (1 - f * s);
       t = v * (1 - (1 - f) * s);
       switch (i % 6) {
           case 0: r = v, g = t, b = p; break;
           case 1: r = q, g = v, b = p; break;
           case 2: r = p, g = v, b = t; break;
           case 3: r = p, g = q, b = v; break;
           case 4: r = t, g = p, b = v; break;
           case 5: r = v, g = p, b = q; break;
       }
       return [
           Math.floor(r * 255),
           Math.floor(g * 255),
           Math.floor(b * 255)
       ];
   }

////////////////////////////////////////////////////////////////////////////////
// Functions
////////////////////////////////////////////////////////////////////////////////
  function getall(){                                                            // Get all infromation
      HUE_GUI.page.ShowPopup(HUE_GUI.wait_data.Name);                           // Popup for wait is showed               
      updatedata();                                                             // Request for update data
   }  
   
   function updatedata(){                                                       // Request for update data
      Check();                                                                  // Disconnect connector recreate 
      dev.Send(["GET" + data[0] + user, data[1]]);                              // Send
   }
      
   function Check(){                                                            // Disconnect Detector is recreate
      remove_disconect_detector();                                              // Destructed
      id_des = IR.SetInterval(1000,  DisconnectDetector);                           // recreate
   }
   
   function remove_disconect_detector(){                                        //  Disconnect Detector is Destructed
      state = 1;
      IR.ClearInterval(id_des);  
   }   
   
   function DisconnectDetector(){                                               // disconect manager 
      state--;
      
      if(state == -5){
         HUE_GUI.page.ShowPopup(HUE_GUI.disconnect.Name);
         remove_disconect_detector();
      } 
  };
   
  function Draw_Lights(){                                                       // driwng the list
      HUE_GUI.light_list.Clear();
      
      for(var i = 0; i < light_array.length; i++){
         HUE_GUI.light_list.CreateItem(i, 2, {Text:  light_array[i].name});
         
         var color_load = HSVtoRGB(light_array[i].hue / 65535, light_array[i].sat / 255, light_array[i].bri / 255) 
         red = color_load[0];
         green = color_load[1];
         blue = color_load[2];
         
         var Z = 0;
         if(light_array[i].swit)
            Z = 1;   
         HUE_GUI.light_list.CreateItem(i, 4, {BorderColor:  red * Z << 24 | green * Z  << 16 | blue * Z  << 8 | 0xFF});
      }
  }  
  
  function setLightNumber(n){                                                   // set light and visible current in the list      
      Draw_Lights();   
      
      light_current = n; 
      HUE_GUI.light_list.CreateItem(n - 1, 1, {Value: 1});
      ColorLoader(); 
   }
   
   function ColorLoader(){
   
      Draw_Lights();
      HUE_GUI.light_list.CreateItem(light_current - 1, 1, {Value: 1});
      HUE_GUI.swit.Value = light_array[light_current - 1].swit;                 // the loading the color
      HUE_GUI.sat.Value  = light_array[light_current - 1].sat;  
      HUE_GUI.bri.Value  = light_array[light_current - 1].bri; 
      
      var color_load = HSVtoRGB(light_array[light_current - 1].hue / 65535, light_array[light_current - 1].sat / 255, light_array[light_current - 1].bri / 255) 
      red = color_load[0];
      green = color_load[1];
      blue = color_load[2];
       
      DisplayColor();   
   }
      
   function DisplayColor(){                                                     // displau the color
      var color_load_2 = red  << 24 | green << 16 | blue << 8 | 0xFF;
      HUE_GUI.swit.GetState(1).FillColor = color_load_2;   
      
      HUE_GUI.sat.GetState(1).FillColor = color_load_2;
      HUE_GUI.sat.GetState(0).FillColor = color_load_2;
      
      HUE_GUI.bri.GetState(1).FillColor = color_load_2;
      HUE_GUI.bri.GetState(0).FillColor = color_load_2;
   } 
   
   function set_switch_sat_bri_hue(){                                           // Setting the propery of the light
      setlight(HUE_GUI.swit.Value ? true : false, HUE_GUI.sat.Value, HUE_GUI.bri.Value, rgb_to_hsv(red, green, blue)[0]); 
      last = function(){
          setlight(HUE_GUI.swit.Value ? true : false, HUE_GUI.sat.Value, HUE_GUI.bri.Value, rgb_to_hsv(red, green, blue)[0]); 
      }
   }
   
   function setSwitch_button(){                                                 // Switcher
      setSwitch(HUE_GUI.swit.Value ? true : false);
   }   
   
   function setNewColor(){                                                      // Set Color via Picker
      color = HUE_GUI.color.PickColor;
      red   = (color  >> 24) & 0xFF;
      green = (color  >> 16) & 0xFF;
      blue  = (color  >> 8)  & 0xFF;      

      HUE_GUI.sat.Value  = rgb_to_hsv(red, green, blue)[1];  
      HUE_GUI.bri.Value  = rgb_to_hsv(red, green, blue)[2];                    
                                                   
      set_switch_sat_bri_hue();
   }
   
   function setlight(on, sat, bri, hue, xy, ct, alert, effect, transitiontime){ // change light property
      Check(); 
      dev.Send(["PUT" + data[2] + light_current + "/state," + "{\"on\":" + on + ",\"sat\":" + sat + ",\"bri\":" + bri + ",\"hue\":" + hue + "}", "\u0000"]); 
   } 
   
   function setSat(light_n, sat){                                                     // change light property
      
      if(sat > 255) sat = 255;
      if(sat < 0)   sat = 0; 
      if(!light_n)
         light_n = light_current;    
      dev.Send(["PUT" + data[2] + light_n + "/state," + "{\"sat\":" + sat + "}", "\u0000"]); 
   }
             
   function setBri(light_n, bri){                                                     // change light property
      
      if(bri > 255) bri = 255;
      if(bri < 0)   bri = 0; 
      if(!light_n)
         light_n = light_current;    
      dev.Send(["PUT" + data[2] + light_n + "/state," + "{\"bri\":" + bri + "}", "\u0000"]); 
   }
   
   function setHUE(light_n, hue_){                                                     // change light property

      if(hue_ > 65535) hue_ = 65535;
      if(hue_ < 0) hue_ = 0; 
      if(!light_n)
         light_n = light_current;    
      dev.Send(["PUT" + data[2] + light_n + "/state," + "{\"hue\":" + hue_ + "}", "\u0000"]); 
   }
   
   function setColor(n, color){                                                 // change light property

      red   = (color  >> 24) & 0xFF;
      green = (color  >> 16) & 0xFF;
      blue  = (color  >> 8)  & 0xFF;      

      var divider_color = rgb_to_hsv(red, green, blue);

      dev.Send(["PUT" + data[2] + n + "/state," + "{\"sat\":" + divider_color[2] + ",\"bri\":" + divider_color[1] + ",\"hue\":" + divider_color[0] + "}", "\u0000"]); 
   }
   
   function setSwitch(on, light_n){                                                      // switch the light
      Check();
      if(!light_n)
         light_n = light_current;             
      dev.Send(["PUT" + data[2] + light_n + "/state," + "{\"on\":" + on + "}", "\u0000"]); 
   }
                                                                                
   function auth(){                                                             // add user
      Check();       
      dev.Send(["POST" + data[0] + ",{\"devicetype\":\"i2controlapp\",\"username\":\"" + user + "\"}", "\u0000"]);     
   }
   
   function getlight(){                                                         // The inf of the light                                                         
      dev.Send(["GET" + data[2] + light_current, data[1]]);                                
   }

////////////////////////////////////////////////////////////////////////////////
// Channels Driver
////////////////////////////////////////////////////////////////////////////////  
   function DataReflection(){ 
   
      for(var i = 0; i < light_array.length; i++){
         dev.SetFeedback("Saturation " + (i + 1), light_array[i].sat);
         dev.SetFeedback("Switch " + (i + 1), light_array[i].swit);
         dev.SetFeedback("Brightness " + (i + 1), light_array[i].bri);
         dev.SetFeedback("HUE " + (i + 1), light_array[i].hue);
      }
   }
   
   function Requester(name, value){
      name = name.split(" "); 
      switch(name[0]){
         case "Switch":
            PUB_switch(name[1], Boolean(value));   
         break;
         
         case "HUE":
             setHUE(name[1], value);
         break;
         
         case "PickColor":
             setColor(name[1], value);
         break;
             
         case "Brightness":
             setBri(name[1], value);
         break;
         
         case "Saturation":
            setSat(name[1], value);
         break;
            
         default:
            IR.Log("The Command not found.");
         break;
      }
   }   
   
////////////////////////////////////////////////////////////////////////////////
// Public functions
////////////////////////////////////////////////////////////////////////////////     
function last(){};
     
   PUB_changeLight = function(n__, sat__, bri__, hue__){
       setSat(n__, sat__);
       setBri(n__, bri__);  
       setHUE(n__, hue__);   
       Check();  
       
       last = function(){
             setSat(n__, sat__);
             setBri(n__, bri__);  
             setHUE(n__, hue__);     
       };
   }
   
   PUB_switch = function(n, on){
      setSwitch(on, n);    
   }
////////////////////////////////////////////////////////////////////////////////
// Subscribe to events  
////////////////////////////////////////////////////////////////////////////////           
   IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.color, setNewColor);   
                                                                                
   IR.AddListener(IR.EVENT_ITEM_SELECT, HUE_GUI.light_list, function(i){        // choose the light via list 
      light_current = i + 1;
                                                                                
      setLightNumber(light_current);   
   });                                                     
    
   IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.sat, set_switch_sat_bri_hue);  // change the sat
                                                                                                                             
   IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.bri, set_switch_sat_bri_hue);  // change the bri
   
   IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.swit, setSwitch_button);       // switch
                                                                                                                      
   IR.AddListener(IR.EVENT_ONLINE, dev,  remove_disconect_detector);            // remove disconnect     
  
   IR.AddListener(IR.EVENT_RECEIVE_TEXT, dev, parse);                           // new message
   
   IR.AddListener(IR.EVENT_CHANNEL_SET, dev, Requester);                        // The channel UI
   getall();                                                                    // autorisation for start
}
////////////////////////////////////////////////////////////////////////////////
// End
////////////////////////////////////////////////////////////////////////////////